
use crate::labled_switch::LabledSwitch;

use glib::subclass::InitializingObject;
use gtk::subclass::prelude::*;
use gtk::{glib, CompositeTemplate};


#[derive(CompositeTemplate, Default)]
#[template(resource = "/org/foxarmy/learn-hieroglyph/guessing/setup/ui.xml")]
pub struct GuessingSetupScene {
    #[template_child]
    pub hiragana_enable: TemplateChild<LabledSwitch>,
    #[template_child]
    pub katakana_enable: TemplateChild<LabledSwitch>,
    #[template_child]
    pub ktr_enable: TemplateChild<LabledSwitch>,
    #[template_child]
    pub rtk_enable: TemplateChild<LabledSwitch>,
}

#[glib::object_subclass]
impl ObjectSubclass for GuessingSetupScene {
    const NAME: &'static str = "GuessingSetupScene";
    type Type = super::GuessingSetupScene;
    type ParentType = gtk::ApplicationWindow;

    fn class_init(klass: &mut Self::Class) {
        klass.bind_template();
    }

    fn instance_init(obj: &InitializingObject<Self>) {
        obj.init_template();
    }
}

impl ObjectImpl for GuessingSetupScene {
    fn constructed(&self) {
        self.parent_constructed();

        //TODO: tie switches to settings and make "start" button
    }
}

impl WidgetImpl for GuessingSetupScene {}

impl WindowImpl for GuessingSetupScene {}

impl ApplicationWindowImpl for GuessingSetupScene {}